Loading...
Searching...
No Matches
pcl::GRSDEstimation< PointInT, PointNT, PointOutT > Class Template Reference
Module features

GRSDEstimation estimates the Global Radius-based Surface Descriptor (GRSD) for a given point cloud dataset containing points and normals. More...

`#include <pcl/features/grsd.h>`

Inheritance diagram for pcl::GRSDEstimation< PointInT, PointNT, PointOutT >:

## Public Types

using | PointCloudOut = typename Feature< PointInT, PointOutT >::PointCloudOut
using | PointCloudIn = typename Feature< PointInT, PointOutT >::PointCloudIn
using | PointCloudInPtr = typename Feature< PointInT, PointOutT >::PointCloudInPtr
Public Types inherited from pcl::FeatureFromNormals< PointInT, PointNT, PointOutT >
using | PointCloudN = pcl::PointCloud< PointNT >
using | PointCloudNPtr = typename PointCloudN::Ptr
using | PointCloudNConstPtr = typename PointCloudN::ConstPtr
using | Ptr = shared_ptr< FeatureFromNormals< PointInT, PointNT, PointOutT > >
using | ConstPtr = shared_ptr< const FeatureFromNormals< PointInT, PointNT, PointOutT > >
Public Types inherited from pcl::Feature< PointInT, PointOutT >
using | BaseClass = PCLBase< PointInT >
using | Ptr = shared_ptr< Feature< PointInT, PointOutT > >
using | ConstPtr = shared_ptr< const Feature< PointInT, PointOutT > >
using | KdTree = pcl::search::Search< PointInT >
using | KdTreePtr = typename KdTree::Ptr
using | PointCloudIn = pcl::PointCloud< PointInT >
using | PointCloudInPtr = typename PointCloudIn::Ptr
using | PointCloudInConstPtr = typename PointCloudIn::ConstPtr
using | PointCloudOut = pcl::PointCloud< PointOutT >
using | SearchMethod = std::function< int(std::size_t, double, pcl::Indices &, std::vector< float > &)>
using | SearchMethodSurface = std::function< int(const PointCloudIn &cloud, std::size_t index, double, pcl::Indices &, std::vector< float > &)>
Public Types inherited from pcl::PCLBase< PointInT >
using | PointCloud = pcl::PointCloud< PointInT >
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
using | PointIndicesPtr = PointIndices::Ptr
using | PointIndicesConstPtr = PointIndices::ConstPtr

## Public Member Functions

| GRSDEstimation ()
| Constructor.
void | setRadiusSearch (double radius)
| Set the sphere radius that is to be used for determining the nearest neighbors used for the feature estimation.
double | getRadiusSearch () const
| Get the sphere radius used for determining the neighbors.
void | setNrSubdivisions (int nr_subdiv)
| Set the number of subdivisions for the considered distance interval.
void | setPlaneRadius (double plane_radius)
| Set the maximum radius, above which everything can be considered planar.
Public Member Functions inherited from pcl::FeatureFromNormals< PointInT, PointNT, PointOutT >
| FeatureFromNormals ()
| Empty constructor.
void | setInputNormals (const PointCloudNConstPtr &normals)
| Provide a pointer to the input dataset that contains the point normals of the XYZ dataset.
PointCloudNConstPtr | getInputNormals () const
| Get a pointer to the normals of the input XYZ point cloud dataset.
Public Member Functions inherited from pcl::Feature< PointInT, PointOutT >
| Feature ()
| Empty constructor.
void | setSearchSurface (const PointCloudInConstPtr &cloud)
| Provide a pointer to a dataset to add additional information to estimate the features for every point in the input dataset.
PointCloudInConstPtr | getSearchSurface () const
| Get a pointer to the surface point cloud dataset.
void | setSearchMethod (const KdTreePtr &tree)
| Provide a pointer to the search object.
KdTreePtr | getSearchMethod () const
| Get a pointer to the search method used.
double | getSearchParameter () const
| Get the internal search parameter.
void | setKSearch (int k)
| Set the number of k nearest neighbors to use for the feature estimation.
int | getKSearch () const
| get the number of k nearest neighbors used for the feature estimation.
void | setRadiusSearch (double radius)
| Set the sphere radius that is to be used for determining the nearest neighbors used for the feature estimation.
double | getRadiusSearch () const
| Get the sphere radius used for determining the neighbors.
void | compute (PointCloudOut &output)
| Base method for feature estimation for all points given in <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod ()
Public Member Functions inherited from pcl::PCLBase< PointInT >
| PCLBase ()
| Empty constructor.
| PCLBase (const PCLBase &base)
| Copy constructor.
virtual | ~PCLBase ()=default
| Destructor.
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset.
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset.
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (std::size_t row_start, std::size_t col_start, std::size_t nb_rows, std::size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud.
IndicesPtr | getIndices ()
| Get a pointer to the vector of indices used.
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used.
const PointInT & | operator[] (std::size_t pos) const
| Override PointCloud operator[] to shorten code.

## Static Public Member Functions

static int | getSimpleType (float min_radius, float max_radius, double min_radius_plane=0.100, double max_radius_noise=0.015, double min_radius_cylinder=0.175, double max_min_radius_diff=0.050)
| Get the type of the local surface based on the min and max radius computed.

## Protected Member Functions

void | computeFeature (PointCloudOut &output) override
| Estimate the Global Radius-based Surface Descriptor (GRSD) for a set of points given by <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod ()
Protected Member Functions inherited from pcl::FeatureFromNormals< PointInT, PointNT, PointOutT >
virtual bool | initCompute ()
| This method should get called before starting the actual computation.
Protected Member Functions inherited from pcl::Feature< PointInT, PointOutT >
const std::string & | getClassName () const
| Get a string representation of the name of this class.
virtual bool | deinitCompute ()
| This method should get called after ending the actual computation.
int | searchForNeighbors (std::size_t index, double parameter, pcl::Indices &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface.
int | searchForNeighbors (const PointCloudIn &cloud, std::size_t index, double parameter, pcl::Indices &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface.
Protected Member Functions inherited from pcl::PCLBase< PointInT >
bool | initCompute ()
| This method should get called before starting the actual computation.
bool | deinitCompute ()
| This method should get called after finishing the actual computation.

## Additional Inherited Members

Protected Attributes inherited from pcl::FeatureFromNormals< PointInT, PointNT, PointOutT >
PointCloudNConstPtr | normals_
| A pointer to the input dataset that contains the point normals of the XYZ dataset.
Protected Attributes inherited from pcl::Feature< PointInT, PointOutT >
std::string | feature_name_
| The feature name.
SearchMethodSurface | search_method_surface_
| The search method template for points.
PointCloudInConstPtr | surface_
| An input point cloud describing the surface that is to be used for nearest neighbors estimation.
KdTreePtr | tree_
| A pointer to the spatial search object.
double | search_parameter_
| The actual search parameter (from either search_radius_ or k_).
double | search_radius_
| The nearest neighbors search radius for each point.
int | k_
| The number of K nearest neighbors to use for each point.
bool | fake_surface_
| If no surface is given, we use the input PointCloud as the surface.
Protected Attributes inherited from pcl::PCLBase< PointInT >
PointCloudConstPtr | input_
| The input point cloud dataset.
IndicesPtr | indices_
| A pointer to the vector of point indices to use.
bool | use_indices_
| Set to true if point indices are used.
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud.

## Detailed Description

template<typename PointInT, typename PointNT, typename PointOutT>
class pcl::GRSDEstimation< PointInT, PointNT, PointOutT >

GRSDEstimation estimates the Global Radius-based Surface Descriptor (GRSD) for a given point cloud dataset containing points and normals.

Note
  If you use this code in any academic work, please cite (first for the ray-casting and second for the additive version):

- Z.C. Marton, D. Pangercic, N. Blodow, Michael Beetz. Combined 2D-3D Categorization and Classification for Multimodal Perception Systems. In The International Journal of Robotics Research, Sage Publications pages 1378–1402, Volume 30, Number 11, September 2011.
- A. Kanezaki, Z.C. Marton, D. Pangercic, T. Harada, Y. Kuniyoshi, M. Beetz. Voxelized Shape and Color Histograms for RGB-D In the Workshop on Active Semantic Perception and Object Search in the Real World, in conjunction with the IEEE/RSJ International Conference on Intelligent Robots and Systems (IROS) San Francisco, California, September 25-30, 2011.

Note
  The code is stateful as we do not expect this class to be multicore parallelized. Please look at FPFHEstimationOMP for examples on parallel implementations of the FPFH (Fast Point Feature Histogram).

Author
  Zoltan Csaba Marton

Template Parameters

  PointOutT | Suggested type is `pcl::GRSDSignature21`

Definition at line 72 of file grsd.h.

## Member Typedef Documentation

## PointCloudIn

template<typename PointInT , typename PointNT , typename PointOutT >

using pcl::GRSDEstimation< PointInT, PointNT, PointOutT >::PointCloudIn = typename Feature<PointInT, PointOutT>::PointCloudIn

Definition at line 86 of file grsd.h.

## PointCloudInPtr

template<typename PointInT , typename PointNT , typename PointOutT >

using pcl::GRSDEstimation< PointInT, PointNT, PointOutT >::PointCloudInPtr = typename Feature<PointInT, PointOutT>::PointCloudInPtr

Definition at line 87 of file grsd.h.

## PointCloudOut

template<typename PointInT , typename PointNT , typename PointOutT >

using pcl::GRSDEstimation< PointInT, PointNT, PointOutT >::PointCloudOut = typename Feature<PointInT, PointOutT>::PointCloudOut

Definition at line 85 of file grsd.h.

## Constructor & Destructor Documentation

## GRSDEstimation()

template<typename PointInT , typename PointNT , typename PointOutT >

pcl::GRSDEstimation< PointInT, PointNT, PointOutT >::GRSDEstimation | ( |  | ) |

inline

Constructor.

Definition at line 90 of file grsd.h.

References pcl::Feature< PointInT, PointOutT >::feature_name_.

## Member Function Documentation

## computeFeature()

template<typename PointInT , typename PointNT , typename PointOutT >

void pcl::GRSDEstimation< PointInT, PointNT, PointOutT >::computeFeature | ( | PointCloudOut & | output | ) |

override protected virtual

Estimate the Global Radius-based Surface Descriptor (GRSD) for a set of points given by <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod ()

Parameters

  output | the resultant point cloud that contains the GRSD feature

Implements pcl::Feature< PointInT, PointOutT >.

Definition at line 65 of file grsd.hpp.

References pcl::Feature< PointInT, PointOutT >::compute(), pcl::Filter< PointT >::filter(), pcl::VoxelGrid< PointT >::getNeighborCentroidIndices(), pcl::PointCloud< PointT >::points, pcl::PCLBase< PointT >::setInputCloud(), pcl::FeatureFromNormals< PointInT, PointNT, PointOutT >::setInputNormals(), pcl::VoxelGrid< PointT >::setLeafSize(), pcl::RSDEstimation< PointInT, PointNT, PointOutT >::setNrSubdivisions(), pcl::RSDEstimation< PointInT, PointNT, PointOutT >::setPlaneRadius(), pcl::Feature< PointInT, PointOutT >::setRadiusSearch(), pcl::VoxelGrid< PointT >::setSaveLeafLayout(), pcl::Feature< PointInT, PointOutT >::setSearchSurface(), and pcl::PointCloud< PointT >::size().

## getRadiusSearch()

template<typename PointInT , typename PointNT , typename PointOutT >

double pcl::GRSDEstimation< PointInT, PointNT, PointOutT >::getRadiusSearch | ( |  | ) | const

inline

Get the sphere radius used for determining the neighbors.

Returns
  the sphere radius used as the maximum distance to consider a point a neighbor

Definition at line 107 of file grsd.h.

References pcl::Feature< PointInT, PointOutT >::search_radius_.

## getSimpleType()

template<typename PointInT , typename PointNT , typename PointOutT >

int pcl::GRSDEstimation< PointInT, PointNT, PointOutT >::getSimpleType | ( | float | min_radius,
|  | float | max_radius,
|  | double | min_radius_plane = `0.100`,
|  | double | max_radius_noise = `0.015`,
|  | double | min_radius_cylinder = `0.175`,
|  | double | max_min_radius_diff = `0.050`
| ) |  |

inline static

Get the type of the local surface based on the min and max radius computed.

Returns
  the integer that represents the type of the local surface with values as Plane (1), Cylinder (2), Noise or corner (0), Sphere (3) and Edge (4)

Definition at line 46 of file grsd.hpp.

## setNrSubdivisions()

template<typename PointInT , typename PointNT , typename PointOutT >

void pcl::GRSDEstimation< PointInT, PointNT, PointOutT >::setNrSubdivisions | ( | int | nr_subdiv | ) |

inline

Set the number of subdivisions for the considered distance interval.

This function configures the underlying RSDEstimation. For more info, see there. If this function is not called, the default from RSDEstimation is used.

Parameters

  [in] | nr_subdiv | the number of subdivisions

Definition at line 115 of file grsd.h.

## setPlaneRadius()

template<typename PointInT , typename PointNT , typename PointOutT >

void pcl::GRSDEstimation< PointInT, PointNT, PointOutT >::setPlaneRadius | ( | double | plane_radius | ) |

inline

Set the maximum radius, above which everything can be considered planar.

This function configures the underlying RSDEstimation. For more info, see there. If this function is not called, the default from RSDEstimation is used.

Parameters

  [in] | plane_radius | the new plane radius

Definition at line 123 of file grsd.h.

## setRadiusSearch()

template<typename PointInT , typename PointNT , typename PointOutT >

void pcl::GRSDEstimation< PointInT, PointNT, PointOutT >::setRadiusSearch | ( | double | radius | ) |

inline

Set the sphere radius that is to be used for determining the nearest neighbors used for the feature estimation.

Same value will be used for the internal voxel grid leaf size.

Parameters

  [in] | radius | the sphere radius used as the maximum distance to consider a point a neighbor

Definition at line 101 of file grsd.h.

References pcl::Feature< PointInT, PointOutT >::search_radius_.

The documentation for this class was generated from the following files:

- pcl/features/grsd.h
- pcl/features/impl/grsd.hpp